typedef struct NOiD_klop
{
	unsigned long int id;		//permanent id , represent the real place in the array
	unsigned long int nfo;		//check sum id , defined higher
	unsigned long int head;		//continuous file
	unsigned long int tail;		//continuous file
	unsigned long int last;
	unsigned long int next;
	unsigned long int back;
	unsigned long int fore;
} NOiD_klop;

NOiD_klop * NOiD_build (int , int , void * );

int NOiD_pop (NOiD_klop * noid_table, int noid_src);
int NOiD_push (NOiD_klop * noid_table, int noid_src, int noid_dest);
int NOiD_last (NOiD_klop * noid_table, int noid_src);
int NOiD_next (NOiD_klop * noid_table, int noid_src);
int NOiD_undo (NOiD_klop * noid_table, int noid_src);
int NOiD_redo (NOiD_klop * noid_table, int noid_src);

void * NOiD_read (void * noid_table, int noid_size, int noid_numb, void * noid_dest);
void * NOiD_write (void * noid_table, int noid_size, int noid_numb, void * noid_src);
